<?php

namespace Amazingcat\Labels\Setup;

use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\DB\Ddl\Table;

/**
 * Class UpgradeSchema
 * @package Amazingcat\Labels\Setup
 */
class UpgradeSchema implements UpgradeSchemaInterface
{
    const TABLE_NAME = 'amazingcat_default_labels';

    /**
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $connection = $installer->getConnection();

        if (version_compare($context->getVersion(), '1.1.6') < 0) {
            $connection->addColumn(
                $installer->getTable('catalogrule'),
                'rule_label',
                [
                    'type'     => Table::TYPE_TEXT,
                    'nullable' => true,
                    'comment'  => 'Rule badge',
                ]
            );
        }

        if (version_compare($context->getVersion(), '1.1.13') < 0) {
            $connection->addColumn(
                $installer->getTable(self::TABLE_NAME),
                'position',
                [
                    'type'     => Table::TYPE_INTEGER,
                    'nullable' => true,
                    'default'  => 0,
                    'comment'  => 'Label position'
                ]
            );
        }

        $installer->endSetup();
    }
}
