<?php

namespace Amazingcat\Labels\Ui\Component\Action;

use Magento\Backend\Model\UrlInterface;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;

/**
 * Class LabelsActionColumn
 * @package Amazingcat\Labels\Ui\Component\Action
 */
class LabelsActionColumn extends Column
{
    /**
     * @var UrlInterface
     */
    protected $urlBuilder;

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param UrlInterface $urlBuilder
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        UrlInterface $urlBuilder,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;

        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    /**
     * Prepare Data Source.
     *
     * @param array $dataSource
     *
     * @return array
     */
    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                $item[$this->getData('name')]['delete'] = [
                    'href'   => $this->urlBuilder->getUrl(
                        'default_labels/actions/delete',
                        ['id' => $item['id']]
                    ),
                    'label'  => __('Delete'),
                    'hidden' => false,
                ];

                $item[$this->getData('name')]['edit'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'default_labels/pages/edit',
                        [
                            'id' => $item['id'],
                            'logo_path '=> $item['image_path'],
                            'position' => $item['position'],
                        ]
                    ),
                    'label' => __('Edit'),
                    'hidden' => false,
                ];
            }

            return $dataSource;
        }
    }
}
